mod Maux logic: 'cl'

incl Mtex

incl Mtexgt

rem 
  \para \bf  Lists.  \end 

appldisp/2 Tex_f2_ln_interval_co
  Fenced(Op('[',0),Infix(Arg(0),25,3,Id(0,'  .. ',0),Arg(1)),Op(')',0))

fun/2 Interval 'Tex_f2_ln_interval_co'
  Interval(m,n) = 0 <- m >= n
  Interval(m,n) = m,Interval(m+1,n) <- m < n

rem 
  \para \bf  General trees.  \end 

rem 
  \para \it  Arithmetization.  \end 

fun/2 Nd 'Tex_f2_gt_nd'
  Nd(x,ts) = 1,x,ts

pred Gtl 'Tex_f1_gt_gtl'
  Gtl(0)
  Gtl(Nd(x1,ts1),ts2) <- N(x1) & Gtl(ts1) & Gtl(ts2)

pred Gt 
  Gt Nd(x,ts) <- N(x) & Gtl(ts)

rem 
  \para \it  Basic operations and predicates.  \end 

fun Szl 'Tex_f1_gt_szl'
  Szl(0) = 0
  Szl(Nd(x1,ts1),ts2) = Szl(ts1)+1+Szl(ts2)

fun Sz 'Tex_f1_gt_sz'
  Sz Nd(x,ts) = Szl(ts)+1

pred/2 Isomorphicl 'Tex_p2_gt_isomorphicl'
  Isomorphicl(0,0)
  Isomorphicl((Nd(x11,ts11),ts12),Nd(x21,ts21),ts22) <- 
    Isomorphicl(ts11,ts21) & Isomorphicl(ts12,ts22)

pred/2 Isomorphic 'Tex_p2_gt_isomorphic'
  Isomorphic(Nd(x1,ts1),Nd(x2,ts2)) <- Isomorphicl(ts1,ts2)

rem 
  \para \it  Traversals.  \end 

fun Postorderl 'Tex_f1_gt_postorderl'
  Postorderl(0) = 0
  Postorderl(Nd(x1,ts1),ts2) = Postorderl(ts1)++(x1,0)++Postorderl(ts2)

fun Postorder 
  Postorder Nd(x,ts) = Postorderl(ts)++(x,0)

